/**************************************************************
 * Single Coil Switch Machine Driver
 * Copyright (c) 2017 by Valerie Valley RR
 * https://sites.google.com/site/valerievalleyrr/
 * https://www.youtube.com/channel/UC0xlWORI1MsZmPu6DptPqdQ
 * https://plus.google.com/u/0/+CTPAHHuKChannel
 * https://www.facebook.com/harinenkov
 * https://vk.com/id120013159
***************************************************************
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see http://www.gnu.org/licenses
***************************************************************
This program allows a Arduino Uno with an Adafruit Motor Shield V1 
https://playground.arduino.cc/Main/AdafruitMotorShield (as well as others)
to be used for control single coil turnout with the toggle switches
or outputs of the DCC++ (https://github.com/DccPlusPlus) with Z command
see wiring.pdf for details

 In program used libraries:
 - Bounce2 https://github.com/thomasfredericks/Bounce2
 - Adafruit Motor https://github.com/adafruit/Adafruit-Motor-Shield-library
***************************************************************/
//Be extremely careful when increasing this value, as this may damage the switch coil
int pulse = 20; //switch pulse durability in milliseconds. 

//----------------------------------*********************************-------------------------------------
//                                  DON'T CHANGE ANYTHING DOWN HERE!
//--------------------------------------------------------------------------------------------------------

#include <Bounce2.h>
Bounce points[4] = Bounce();

#include <AFMotor.h>
AF_DCMotor motor0(1);
AF_DCMotor motor1(2);
AF_DCMotor motor2(3);
AF_DCMotor motor3(4);

AF_DCMotor motor[4] = {motor0, motor1, motor2, motor3};
int motorPin[4]= {15, 16, 17, 18};
int i;
unsigned long now;
unsigned long motorRun[4];

void setup() {
  for(i=0; i<4; i++){
    pinMode(motorPin[i], INPUT_PULLUP);
    points[i].attach(motorPin[i]);
    points[i].interval(5);
    motor[i].setSpeed(255);
    if(digitalRead(motorPin[i])){
      motor[i].run(FORWARD);
    }
    else {
      motor[i].run(BACKWARD);
    }
    motorRun[i] = 1;
  }
}

void loop() {
  now = millis();
  for(i=0; i<4; i++){
    if(motorRun[i] > 0 && motorRun[i]+pulse < now){
      motor[i].run(RELEASE);
      motorRun[i] = 0;
    }
    if(points[i].update()){
      if(points[i].read() == HIGH) {
        motor[i].run(FORWARD);
      }
      else {
        motor[i].run(BACKWARD);
      }
      motorRun[i] = now;
    }
  }

}

